'' ******************************************************************************
'' * Send the 303 results to wixel then capture them in a graph                  *
'' ******************************************************************************
''

CON
  _clkmode = xtal1 + pll16x     'Standard clock mode * crystal frequency = 80 MHz
  _xinfreq = 5_000_000          


   

'' LSM303DLM registers as taken directly from the LSM303DLM datasheet
'' name         |  Hex address  | binary | default
R''eserved (do not modify) Table 12 -- 00 - 1F -- -- Reserved
CTRL_REG1_A =     $20           '010 0000 00000111
CTRL_REG2_A =     $21           '010 0001 00000000
CTRL_REG3_A =     $22           '010 0010 00000000
CTRL_REG4_A =     $23           '010 0011 00000000
CTRL_REG5_A =     $24           '010 0100 00000000
HP_FILTER_RESET_A = $25         '010 0101 -- Dummy register
REFERENCE_A =     $26           '010 0110 00000000
STATUS_REG_A =    $27           '010 0111 00000000
OUT_X_L_A =       $28           '010 1000 output
OUT_X_H_A =       $29           '010 1001 output
OUT_Y_L_A =       $2A           '010 1010 output
OUT_Y_H_A =       $2B           '010 1011 output
OUT_Z_L_A =       $2C           '010 1100 output
OUT_Z_H_A =       $2D           '010 1101 output
''Reserved (do not modify) Table 12 -- 2E - 2F -- -- Reserved
INT1_CFG_A =      $30           '011 0000 00000000
INT1_SOURCE_A =   $31           '011 0001 00000000
INT1_THS_A =      $32           '011 0010 00000000
INT1_DURATION_A = $33           '011 0011 00000000
INT2_CFG_A =      $34           '011 0100 00000000
INT2_SOURCE_A =   $35           '011 0101 00000000
INT2_THS_A =      $36           '011 0110 00000000
INT2_DURATION_A = $37           '011 0111 00000000
''Reserved (do not modify) Table 12 -- 38 - 3F -- -- Reserved
CRA_REG_M =       $00           '00000000 00010000
CRB_REG_M =       $01           '00000001 00100000
MR_REG_M =        $02           '00000010 00000011
OUT_X_H_M =       $03           '00000011 output
OUT_X_L_M =       $04           '00000100 output
OUT_Y_H_M =       $07           '00000101 output
OUT_Y_L_M =       $08           '00000110 output
OUT_Z_H_M =       $05           '00000111 output
OUT_Z_L_M =       $06           '00001000 output
SR_REG_Mg =       $09           '00001001 00000000
IRA_REG_M =       $0A           '00001010 01001000
IRB_REG_M =       $0B           '00001011 00110100
IRC_REG_M =       $0C           '00001100 00110011
''Reserved (do not modify) Table 14 -- 0D - 0E -- -- Reserved
WHO_AM_I_M = $0F                '00001111 00111100 Who am I ID
''Reserved (do not modify) Table 14 -- 10 - 3A -- -- Reserved


{{
Accel addr table
Table 12. SAD and read/write patterns
Command SAD[6:1] SAD[0] = SA0 R/W SAD+R/W
Read 001100 0 1 00110001 (31h)
Write 001100 0 0 00110000 (30h)
Read 001100 1 1 00110011 (33h)
Write 001100 1 0 00110010 (32h)

Magnetometer Addr table:
Table 14. SAD and read/write patterns
Command SAD[6:0] R/W SAD+R/W
Read 0011110 1 00111101 (3Dh)
Write 0011110 0 00111100 (3Ch)
}}


'' L3GD20 registers as taken directly from the L3GD20 datasheet
'' name         |  Hex address  | binary | default
''Reserved - 00-0E - -
WHO_AM_I =      $0F             ''000 1111 11010100
''Reserved -    10-1F - -
CTRL_REG1 =     $20            '' 010 0000 00000111
CTRL_REG2 =     $21             ''010 0001 00000000
CTRL_REG3 =     $22             ''010 0010 00000000
CTRL_REG4 =     $23             ''010 0011 00000000
CTRL_REG5 =     $24             ''010 0100 00000000
REFERENCE =     $25             ''010 0101 00000000
OUT_TEMP =      $26             ''010 0110 output
STATUS_REG =    $27             ''010 0111 output
OUT_X_L =       $28             ''010 1000 output
OUT_X_H =       $29             ''010 1001 output
OUT_Y_L =       $2A             ''010 1010 output
OUT_Y_H =       $2B             ''010 1011 output
OUT_Z_L =       $2C             ''010 1100 output
OUT_Z_H =       $2D             ''010 1101 output
FIFO_CTRL_REG = $2E             ''010 1110 00000000
FIFO_SRC_REG =  $2F             ''010 1111 output
INT1_CFG =      $30             ''011 0000 00000000
INT1_SRC =      $31             ''011 0001 output
INT1_TSH_XH =   $32             ''011 0010 00000000
INT1_TSH_XL =   $33             ''011 0011 00000000
INT1_TSH_YH =   $34             ''011 0100 00000000
INT1_TSH_YL =   $35             ''011 0101 00000000
INT1_TSH_ZH =   $36             ''011 0110 00000000
INT1_TSH_ZL =   $37             ''011 0111 00000000
INT1_DURATION = $38             ''011 1000 00000000

{{
L3GD20, Table 12. SAD+read/write patterns
ommand  SAD[6:1]  SAD[0] = SDO  R/W                     SAD+R/W
Read    110101    0             1                       11010101 (D5)
Write   110101    0             0                       11010100 (D4)
Read    110101    1             1                       11010111 (D7)
Write   110101    1             0                       11010110 (D6)

Rt =angular rate in Degrees per second
SC = scale factor
Rm = Raw measurement
R0 = zero rate offset
Rt = SC*(Rm-R0)

Sensitivity in mdps/digit =250 dps = 0.00875 per digit
Set FS bits in CntrlReg4 
FS = 250 dps 8.75
FS = 500 dps 17.50 
FS = 2000 dps 70


}}


  Mrdy = 2      '' Magnetometer data ready input pin
  Grdy = 3      '' Gyro data ready pin
  SCL = 6 
  SDA = 7
  AccW = $30
  MagW = $3C
  GyrW = $D6                                            
  Gw = 3.0         '' gyro weighting use values from 5-20 expirimentally
  LED =16
  QikRx = 12
  QikTx = 13
  QikAdd = 10                                                                      
            
VAR

 long ackbit
 long sts
 long LastMode
 
 long Mode
 long Ic2Cog, FpCog, DebugCog, AngCog, FpStrCog, qikcog
 Long AngStack[240]
 long EstAng, DTime, D1,D2, AccelX, AccelZ, GyroY, Anglst, AngVel, Ang, AccStatus, GyrStatus
 Long GyAng, T, DAng, Force, GyrConv, NAccelX, NAccelZ 
 Long Speed, AngleSetPoint, Kp, Ki, Kd, QikErr,ThisErr, Prop, Int, Der, DeltaErr, AccumErr, LastErr, IntSpeed     
  
OBJ

Debug   : "Parallax Serial Terminal Plus"
i2c     : "i2c"
FpStr   : "FloatString"
Fp32    : "Float32"
FME     : "FME"
Qik     : "QiKCommands"
      
PUB MainControl         | QikPara, QikValue


  dira[Mrdy]~    '' Magnetometer  data ready pin is an input                                     
  dira[Grdy]~    '' Gyro data ready pin is an input  
  Kp := 2.0
  Ki := 0.0
  Kd := 0.0
  AngleSetpoint := 10.0
   

     
  debugcog := debug.startRxTx  (0, 1, 0, 115_200)        '' starts the serial debugger
  dira[8..11]~                                          '' dip switch inputs 
  LastMode := 0
  debug.clear
  FpCog := fp32.start
  waitcnt((clkfreq) + CNT)
  FpStrCog := FpStr.start
  waitcnt((clkfreq) + CNT)
  i2c.init(SDA, SCL, TRUE) 
  ''Fpstr.SetPrecision(3)                         




  StopAngCog
  AngCog := cognew(Angl , @AngStack) + 1  
  waitcnt((clkfreq * 3) + CNT)
                                      
  '' Start teh Qik, use default parameters 
  QikCog := Qik.Init( QikRx, QikTx)  
  waitcnt((clkfreq) + CNT)


  Debug.str(string("Accel status : "))
  Debug.bin(i2c.read(accw, STATUS_REG_A,8,8), 8)
  Debug.newline
  Debug.str(string("Gyro status : "))
  Debug.bin(i2c.read(GyrW, STATUS_REG,8,8),8)
  Debug.newline
  Debug.str(string("Main Cog : "))
  debug.dec(CogID)
  Debug.newline
  Debug.str(string("Debug Cog : "))
  Debug.dec(debugcog)
  Debug.newline
  Debug.str(string("FP cog : "))
  Debug.dec(FpCog)
  Debug.newline
  Debug.str(string("FP string Cog : "))
  Debug.dec(FpStrCog)
  Debug.newline
  Debug.str(string("Angle cog : "))
  Debug.dec(AngCog)
  Debug.newline   
  Debug.str(string("Qik Serial cog : "))
  Debug.dec(QikCog)
  Debug.newline         
        
          
  
  ''---- Qik and PID----- Set up  
  ''Speed, AngleSetPoint, Kp, Ki, Kd
  ''dira[QikRx]~                 '' Rx is input
  ''dira[QikTx]~~                '' Tx is an output
   


  Debug.str(string(13,"List parameters",13))
  repeat QikPara from 0 to 11 '' MaxParameters
    debug.dec(QikPara)
    debug.str(string(" "))
    QikValue:=QiK.GetParameter(QikAdd,QikPara)  'get parameter value
    Debug.str(QiK.Par2Str(QikPara))
    debug.dec(QikValue)
    debug.newline
  
  waitcnt((clkfreq * 3) + CNT)   '' wait a second

    


  waitcnt(500_000 + cnt)                                '' allow the sensors to settle a bit 
   debug.str(string("Starting pid loop"))
   debug.newline
  repeat
    ''debug.dec(mode)
    
    LastErr := ThisErr
    ThisErr := Fp32.Fsub (AngleSetPoint, EstAng)
    AccumErr := 0.0  '''Fp32.fadd (AccumErr, ThisErr)
 
    DeltaErr := Fp32.FSub(ThisErr, LastErr)

    Prop := Fp32.FMul (ThisErr, Kp)
    Int  := 0.0 ''Fp32.FMul(AccumErr, Ki)  
    Der  := Fp32.FMul (DeltaErr, Kd)
    Speed:= Fp32.FAdd(Prop, Int)
    Speed:= Fp32.FAdd(Speed, Der)
    intSpeed := fp32.FTrunc(Speed)       
    Qik.SetSpeedM0(QikAdd,intSpeed)     '' M0 
    Qik.SetSpeedM1(QikAdd,intSpeed)     '' M1


        ''debug.str(string(" eAng:"))
        ''debug.str(FpStr.FloatToString(EstAng))


        ''debug.str(string(" tErr:"))
        ''debug.str(FpStr.FloatToString(ThisErr))
        ''debug.str(string(" lErr:"))   
        ''debug.str(FpStr.FloatToString(LastErr))
        ''debug.str(string(" aErr:"))
        ''debug.str(FpStr.FloatToString(AccumErr))
        ''debug.str(string(" dErr:"))
        ''debug.str(FpStr.FloatToString(DeltaErr))
        ''debug.str(string(" P:"))
        ''debug.str(FpStr.FloatToString(Prop))
        ''debug.str(string(" I:"))
        ''debug.str(FpStr.FloatToString(Int))
        ''debug.str(string(" D:"))
        ''debug.str(FpStr.FloatToString(Der))
        ''debug.str(string(" fpSpd:"))
        ''debug.str(FpStr.FloatToString(Speed))
        ''debug.str(string(" iSpd:"))
        debug.bin(IntSpeed, 32)
        debug.newline
     
    ''senddata
 
    waitcnt(1_000_000 + cnt) 

PUB StopAngCog

  if AngCog
     cogstop(AngCog~ - 1)
    


    
PUB Angl     



  GyrConv := fp32.Fdiv(875.0,100000.0)              '' 250 dps = 0.00875 per digit
  dira[16]~~                                            '' LED on pin 16  
  AccelX := 1
  AccelZ := 1

'' initiallize the Accelerometer
  i2c.write(accw, CTRL_REG1_A, %0011_0111,8)       ''0011_0111 = 400Hz enable all 3 accel axis
  i2c.write(accw, CTRL_REG2_A, %0000_0000,8)       ''0001_0000 = enable filtered data
  i2c.write(Magw, CRA_REG_M, %0001_1100, 8)         ''0001_1100 =  update at 220 hz 
  '' Initialize the magnetometer 
  ''i2c.write(Magw, CRB_REG_M, %0010_0000,8)         ''0010_0000 = 1.3Gauze
  ''i2c.write(Magw, MR_REG_M, %0000_0000,8)          ''0000_0000 = continuous conversion mode
  '' Initialize the Gyro
  i2c.write(GyrW, CTRL_REG1, %1001_1111,8)             ''CTRL_REG1 1001_1111 = 380 Hz, power up, all thre axis enabled
  i2c.write(GyrW, CTRL_REG4, %1000_0000,8)             ''CTRL_REG4  1000_0000 = do not allow read and write at teh same time, 500DPS, SPI not used
  i2c.write(GyrW, CTRL_REG5, %0000_0000,8)             '' FIFO disabled 

      
 Repeat
  

    !outa[16]                                           '' toggle LED pulse
    {{  --== Accelerometer ==--}}
    accStatus := i2c.read(accw, STATUS_REG_A,8,8)
    if accStatus[4] == 1  '' & %00001000 == %00001000        '' check for acceleromter data ready
      D1:= i2c.read(accw, OUT_X_H_A,8,8)         '' get the raw readings
      D2:= i2c.read(accw, OUT_X_L_A,8,8)
      AccelX :=  ~D1 << 8 | D2             '' assemble the raw data    
      
      D1 := i2c.read(accw, OUT_Z_H_A,8,8)
      D2:= i2c.read(accw, OUT_Z_L_A,8,8)
      AccelZ :=  ~D1 << 8 | D2
      ''debug.Str(string(" hello "))
      
   {{ --== Gyroscope ==--  }}
    GyrStatus := i2c.read(GyrW, STATUS_REG,8,8)
    if GyrStatus[4] == 1  '' & %0000_1000 == %0000_1000            '' check Status register for Gyro data ready pin high
      D1:= i2c.read(GyrW, OUT_Y_H,8,8)
      D2:= i2c.read(GyrW, OUT_Y_L,8,8)
      GyroY := ~D1 << 8 | D2                              

    Force := fp32.FSqr(fp32.fadd(fp32.Pow( fp32.ffloat(AccelX),2.0), fp32.Pow( fp32.ffloat(AccelZ),2.0) ))
    NAccelX := fp32.fdiv(fp32.ffloat(AccelX), Force)   '' normalize X and Z using the current force  X/force results in 0-1 range 
    NAccelZ := fp32.fdiv(fp32.ffloat(AccelZ), Force)
    Ang := fp32.Degrees(FME.atan2(NAccelX, NAccelZ))  ''use normalized values to calc the ESTIMATED angle   
    AngVel := fp32.fmul(GyrConv,fp32.ffloat(GyroY))   '' deg/sec
    DTime := fp32.fdiv(fp32.ffloat(cnt-T), fp32.ffloat( clkfreq)) '' seconds, a very small number 
    T := cnt
    DAng := fp32.fmul(DTime, AngVel)    '' degrees
    GyAng := fp32.fadd (Anglst, DAng)  '' degrees
    EstAng := fp32.fdiv((fp32.fmul(fp32.fadd(Ang, GyAng), Gw )),  (fp32.fadd(1.0, Gw)))
    if fp32.fcmp(estAng, -180.0) == -1
      EstAng := -180.0
    else
       if fp32.fcmp(estAng, 180.0) == 1
         estang := 180.0
         
     
    Anglst := EstAng
    waitcnt(100_000 + cnt) 
    
      
  
PUB SendData  | ind1, ind2 , TmpCV, TmpRaw, TmpRt        '' sends debug information according to dip switch selection
  
  ind1 := 15  '' first indent 
  ind2 := 30  '' second indent
  mode := Ina [8..11] ' dip switch on pins 8, 9, 10, and 11
  
  case Mode

    %0001:  '' output the angle to graph

        debug.str(string("tErr:"))
        debug.str(FpStr.FloatToString(ThisErr))
        debug.str(string(" lErr:"))   

        debug.str(FpStr.FloatToString(LastErr))
        debug.str(string(" aErr:"))
        debug.str(FpStr.FloatToString(AccumErr))
        debug.str(string(" dErr:"))
        debug.str(FpStr.FloatToString(DeltaErr))
        debug.str(string(" P:"))
        debug.str(FpStr.FloatToString(Prop))
        debug.str(string(" I:"))
        debug.str(FpStr.FloatToString(Int))
        debug.str(string(" D:"))
        debug.str(FpStr.FloatToString(Der))
        debug.str(string(" fpSpd:"))
        debug.str(FpStr.FloatToString(Speed))
        debug.str(string(" iSpd:"))
        debug.dec(IntSpeed)


        debug.newline

    %0011:           
       if not (Lastmode == %0000_0011)
         debug.clear
         debug.str(string("----=====Qik  Debug====-----  "))
         debug.newline
         debug.str(string("Est angle : "))
         debug.newline
         debug.str(string("Setp angle : "))  
         debug.newline
         debug.str(string("----Out put Speed----"))  
         debug.newline
         debug.str(string("FP Speed :"))  
         debug.newline
         debug.str(string("Int Speed :"))  
         debug.newline
         debug.str(string("M0 speed : "))  
         debug.newline                  
         debug.str(string("M1 speed : "))  
         debug.newline
         debug.str(string("--------------------"))  
         debug.newline
         debug.str(string("Qik Error : "))  
         debug.newline
         debug.str(string("This Err : "))  
         debug.newline         
         debug.str(string("Acumm Error : "))  
         debug.newline
         debug.str(string("Delta Err : "))  
         debug.newline
         debug.str(string("Kp : "))  
         debug.newline
         debug.str(string("Prop : "))  
         debug.newline
         debug.str(string("Ki : "))  
         debug.newline
         debug.str(string("Interg : "))  
         debug.newline
         debug.str(string("Kd : "))  
         debug.newline
         debug.str(string("Deriv : "))  
         debug.newline                                                      

         
      debug.Position(ind1, 1) 
      debug.str(FpStr.FloatToString(EstAng))
      debug.clearend        
      debug.position(ind1,2)
      debug.Str(FpStr.FloatToString(AngleSetPoint))              
      debug.clearend
      debug.position(ind1,4)
      debug.Str(FpStr.FloatToString(Speed))              
      debug.clearend
      debug.position(ind1,5)
      debug.dec(IntSpeed)              
      debug.clearend
      debug.position(ind1,6)
      debug.dec(Qik.GetSpeedM0(QikAdd))              
      debug.clearend
      debug.position(ind1,7)
      debug.dec(Qik.GetSpeedM0(QikAdd))              
      debug.clearend
      debug.position(ind1,9)
      debug.Str(Qik.SetParRes2str(Qik.GetError(qikadd)))              
      debug.clearend
      debug.position(ind1,10)
      debug.Str(FpStr.FloatToString(ThisErr))              
      debug.clearend
      debug.position(ind1,11)
      debug.Str(FpStr.FloatToString(AccumErr))              
      debug.clearend
      debug.position(ind1,12)
      debug.Str(FpStr.FloatToString(DeltaErr))              
      debug.clearend                                          
      debug.position(ind1,13)
      debug.Str(FpStr.FloatToString(Kp))              
      debug.clearend
      debug.position(ind1,14)
      debug.Str(FpStr.FloatToString(Prop))              
      debug.clearend
      debug.position(ind1,15)
      debug.Str(FpStr.FloatToString(Ki))              
      debug.clearend
      debug.position(ind1,16)
      debug.Str(FpStr.FloatToString(Int))              
      debug.clearend
      debug.position(ind1,17)
      debug.Str(FpStr.FloatToString(Kd))              
      debug.clearend
      debug.position(ind1,18)
      debug.Str(FpStr.FloatToString(Der))              
      debug.clearend                                


  LastMode := mode
 